% Computes upper and lower bounds on the price of a basket with uniform weigths 
% given the market data from HLW04.
% Number of stocks/strikes considered
load('DowData');
ns=30;fk=1;nk=11;
% Target option
w0=0.071*(30/ns)*ones(1,ns);
k0=90;
% Tolerance
tol=0.00001;
% Working variables
euc=eye(ns);optl=[];
% Include forwards
W=[];p=[];K=[];q=newforwards(1:ns)';
% Option price constraints
for i=1:ns
    j=fk;
    while (j<=(nk+fk-1))
        if (strikes(i,j)>0)
            W=[W;euc(i,:)];K=[K;strikes(i,j)];p=[p;newprices(i,j)];
        end
        j=j+1;
    end
    j=j-1;
end
tic;
res=[];
for strk=[52,56,60,64,68,70,72,76,80,84,88,90,92,94,95,96,97,98,99,100,102,103,104,105,106,107]
    [x,fvalmin,y]=convexbounds(W,K,p,q,w0,strk,-1,tol);
    [x,fvalmax,y]=convexbounds(W,K,p,q,w0,strk,1,tol);
    res=[res;[strk,fvalmin,fvalmax]];disp(num2str([strk,fvalmin,fvalmax]));
end
toc
save('results','res');