function [prc,error]=MCbasket(w,strk,S0,cova,T,nsteps)
% Computes the MC price of a basket call with weights w and strike K
n=length(w);
sam=randn(nsteps,5)*sqrt(T);
sam=sam*chol(cova);
sam=sam-0.5*ones(nsteps,5)*diag(diag(cova))*T;
S=exp(sam)*diag(S0);
C=max([(S*w-strk*ones(nsteps,1))';zeros(1,nsteps)]);
prc=mean(C);
error=1.96*std(C)/sqrt(nsteps);