% Test bounds on a basket option given other basket option prices
load('SwaptionData');
res=[];
tol=0.001;
% Strike prices to test
strikes=(.9:.01:1.1)*(w0*r0');
for k=strikes
    [x,fvalmin,y]=convexbounds(inw,K,p,q,w0,k,-1,tol,'linprog');
    [x,fvalmax,y]=convexbounds(inw,K,p,q,w0,k,1,tol,'linprog');
    res=[res;[k,fvalmin,fvalmax]];disp(num2str([k,fvalmin,fvalmax]));
end
% Simple lower bound
simp=max([w0*r0'-strikes;zeros(1,length(strikes))]);
% Plot everything (prices)
plot(res(:,1),res(:,2),res(:,1),res(:,3),'--',res(:,1),simp,':')
xlabel('k');
ylabel('price');
% Compute implied vols
vres=[];
for k=1:length(strikes)
    volmin=blsimpv(r0*w0',res(k,1), 0,2, res(k,2));
    volmax=blsimpv(r0*w0',res(k,1), 0,2, res(k,3));
    vres=[vres;[strikes(k),volmin,volmax]];disp(num2str([k,volmin,volmax]));
end
figure
plot(vres(:,1),vres(:,2),vres(:,1),vres(:,3),'--','LineWidth',1.5)
axis([strikes(1) strikes(length(strikes)) 0 0.3])
xlabel('k');
ylabel('vol');
save('SwaptionRes');